﻿<?xml version="1.0" encoding="utf-8"?>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd">
    <head>
        <link href="../Resources/TableStyles/Nested-Table.css" rel="stylesheet" MadCap:stylesheetType="table" />
        <link href="../Resources/TableStyles/Default-Table.css" rel="stylesheet" MadCap:stylesheetType="table" /><title>Creating Request Rules</title>
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" type="text/css" />
    </head>
    <body>
        <h1><a name="top"></a>Creating Request Rules</h1>
        <p>Request rule is used in conjunction with Organization identity object. Request rules are evaluated when you are requesting access from ARS for: single user, multi-user or bulk-upload user requests.&#160;To understand request rule, lets go through below use-case example.&#160;</p>
        <p>As a sample use-case, consider a requirement to automatically include access to specific associated entitlements belonging to a specific organization (for example: New Delhi) when user requests access for a specific endpoint and selects the city as New Delhi.</p>
        <p>To address auto-assigning of associated entitlements, you need to create a request rule. To address the above requirement, following example configuration can be done:</p>
        <ul>
            <li>
                <p>Create Organizations (Assign specific Entitlements, add custom attributes (org name, team name, endpoint name <b>X (this is how you associate orgs with endpointX)</b></p>
            </li>
            <li>
                <p>In the endpoint, add dynamic attributes,&#160;<b>Org</b> (query should get org names associated with endpoint X), Team <b>(query should get team names associated with endpoint X)</b></p>
            </li>
            <li>
                <p>Request Rule – If endpoint is <strong>X</strong><em>AND</em> attribute Org selected, include entitlements in the request which are assigned to that Org, which the requestor would pick on the request form.</p>
            </li>
        </ul>
        <p>Execution:</p>
        <ul>
            <li>Requestor selects endpoint <strong>X</strong> during request creation, choses values for dynamic attribute showing up as dropdowns on UI for <strong>Org</strong> and <strong>Team</strong>.</li>
            <li>Accordingly, the respective entitlements assigned to corresponding orgs automatically get included in the request.</li>
        </ul>
        <p>Once it matches the condition, the actions specified in the Request Rule are taken and upon approval access is granted or revoked. For example, in this use case, if there is an access request in ARS for a particular endpoint and in organization populated in dynamic attribute in ARS if 'New Delhi' is selected then associated entitlements from selected organization (in this case New Delhi) are automatically assigned to the requestor.&#160;</p>
        <p>The request rule is fired, when a user's account/access is approved, you need to run the <b>WSRetry job</b> in <b>ADMIN &gt; Job Control Panel &gt; Utility</b>. Provisioning/de-provisioning tasks will be created in <b>ARS &gt; Pending Task</b> for entitlement list which results from request rule firing.</p>
        <p>To create request rule, perform the following steps:</p>
        <ol>
            <li>Go to <strong>ADMIN &gt;&#160;Policies&#160; &gt; Request Rule</strong>.</li>
            <li>Click the <strong>Actions</strong> arrow and select <strong>Create Request Rule</strong>.</li>
            <li>
                <p class="auto-cursor-target">Provide values in the <strong>Create Request Rule</strong> parameters and click <strong>Send for Approval</strong>.</p>
                <table style="width: 100%;mc-table-style: url('../Resources/TableStyles/Nested-Table.css');" class="TableStyle-Nested-Table" cellspacing="0">
                    <col style="width: 24.7482%;" class="TableStyle-Nested-Table-Column-Column1" />
                    <col style="width: 75.2518%;" class="TableStyle-Nested-Table-Column-Column1" />
                    <thead>
                        <tr class="TableStyle-Nested-Table-Head-Header1">
                            <th class="TableStyle-Nested-Table-HeadE-Column1-Header1">Parameter</th>
                            <th class="TableStyle-Nested-Table-HeadD-Column1-Header1">Description</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr class="TableStyle-Nested-Table-Body-Body1">
                            <td colspan="1" class="TableStyle-Nested-Table-BodyE-Column1-Body1">
                                <p class="table-text">Enter Rule Name*</p>
                            </td>
                            <td colspan="1" class="TableStyle-Nested-Table-BodyD-Column1-Body1">
                                <p class="table-text">Enter the appropriate rule name.</p>
                            </td>
                        </tr>
                        <tr class="TableStyle-Nested-Table-Body-Body1">
                            <td colspan="1" class="TableStyle-Nested-Table-BodyE-Column1-Body1">
                                <p class="table-text">Rule Description</p>
                            </td>
                            <td colspan="1" class="TableStyle-Nested-Table-BodyD-Column1-Body1">
                                <p class="table-text">Enter the appropriate rule description.</p>
                            </td>
                        </tr>
                        <tr class="TableStyle-Nested-Table-Body-Body1">
                            <td class="TableStyle-Nested-Table-BodyD-Column1-Body1" colspan="2">
                                <p class="table-text"><strong>Rule Owner -&#160;</strong>
                                </p>
                                <p class="table-text">To add rule owner, click on the +Add Rule Owner and select one or more checkbox. The rule owner details appear in the following columns.</p>
                                <p class="table-text">Identity Access Rules defined are displayed to Rule Owners and to Admin User only. Users who are not rule owners or Admin user cannot view the Identity Access Rules defined. This has been provided to enforce security and regulate control on rules only to users who should be governing any modification to the rules.</p>
                                <p class="table-text">The purpose of rule owner is, viewing of the respective rule can only be done by rule owner and admin. In addition, rule owner is also used for rule modification approvals. If there is a workflow associated from <b>ADMIN &gt; Global Configurations &gt; Rules &gt; Rule Modification Workflow</b>.</p>
                            </td>
                        </tr>
                        <tr class="TableStyle-Nested-Table-Body-Body1">
                            <td colspan="1" class="TableStyle-Nested-Table-BodyE-Column1-Body1">
                                <p class="table-text">Username</p>
                            </td>
                            <td colspan="1" class="TableStyle-Nested-Table-BodyD-Column1-Body1">
                                <p class="table-text">Displays the username of the rule owner.</p>
                            </td>
                        </tr>
                        <tr class="TableStyle-Nested-Table-Body-Body1">
                            <td colspan="1" class="TableStyle-Nested-Table-BodyE-Column1-Body1">
                                <p class="table-text">Rank</p>
                            </td>
                            <td colspan="1" class="TableStyle-Nested-Table-BodyD-Column1-Body1">
                                <p class="table-text">Displays the rank of the rule owner. You can update the Rule Owner Rank as per your requirement. The benefit of specifying Rule Owner is that it provides you the capability to send the Rule Approval to specific Rank owners using a custom query defined in the workflow. Using Workflow, you can specify to which Rank Owners the Rule should be sent for approval.</p>
                            </td>
                        </tr>
                        <tr class="TableStyle-Nested-Table-Body-Body1">
                            <td colspan="1" class="TableStyle-Nested-Table-BodyE-Column1-Body1">
                                <p class="table-text">First Name</p>
                            </td>
                            <td colspan="1" class="TableStyle-Nested-Table-BodyD-Column1-Body1">
                                <p class="table-text">Displays the first name of the rule owner.</p>
                            </td>
                        </tr>
                        <tr class="TableStyle-Nested-Table-Body-Body1">
                            <td colspan="1" class="TableStyle-Nested-Table-BodyE-Column1-Body1">
                                <p class="table-text">Last Name</p>
                            </td>
                            <td colspan="1" class="TableStyle-Nested-Table-BodyD-Column1-Body1">
                                <p class="table-text">Displays the last name of the rule owner.</p>
                            </td>
                        </tr>
                        <tr class="TableStyle-Nested-Table-Body-Body1">
                            <td colspan="1" class="TableStyle-Nested-Table-BodyE-Column1-Body1">
                                <p class="table-text">City</p>
                            </td>
                            <td colspan="1" class="TableStyle-Nested-Table-BodyD-Column1-Body1">
                                <p class="table-text">Displays the name of the city.</p>
                            </td>
                        </tr>
                        <tr class="TableStyle-Nested-Table-Body-Body1">
                            <td colspan="1" class="TableStyle-Nested-Table-BodyE-Column1-Body1">
                                <p class="table-text">Email</p>
                            </td>
                            <td colspan="1" class="TableStyle-Nested-Table-BodyD-Column1-Body1">
                                <p class="table-text">Displays the email address of the rule owner.</p>
                            </td>
                        </tr>
                        <tr class="TableStyle-Nested-Table-Body-Body1">
                            <td colspan="1" class="TableStyle-Nested-Table-BodyE-Column1-Body1">
                                <p class="table-text">Comments</p>
                            </td>
                            <td colspan="1" class="TableStyle-Nested-Table-BodyD-Column1-Body1">
                                <p class="table-text">Displays the comments specified for the user from the User show page. The comments field is extracted from the User show page metadata.</p>
                            </td>
                        </tr>
                        <tr class="TableStyle-Nested-Table-Body-Body1">
                            <td colspan="1" class="TableStyle-Nested-Table-BodyB-Column1-Body1">
                                <p class="table-text">End Date</p>
                            </td>
                            <td colspan="1" class="TableStyle-Nested-Table-BodyA-Column1-Body1">
                                <p class="table-text">Displays the end date specified for the user from the User show page. The End Date field is extracted from the User show page metadata.&#160;Displays the end date of the user till when the user is active in IGA. If there is no end date specified, it does not show any value.</p>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </li>
            <li>
                <p class="auto-cursor-target">The <strong>Conditions</strong> section, precisely is used to define the condition based on Objects such as: Users, Endpoints, Attribute, or Entitlement. In addition, you can also specify the Attribute, Condition, Value and Next Condition. Based on the condition defined, when a request from ARS is performed, if it matches the given condition in Request Rule, it automatically triggers the Actions defined. Based on the specified actions, entitlements or associated entitlements are added or removed from organization.</p>
                <table class="TableStyle-Default-Table" style="mc-table-style: url('../Resources/TableStyles/Default-Table.css');width: 100%;" cellspacing="0">
                    <col class="TableStyle-Default-Table-Column-Column1" />
                    <col class="TableStyle-Default-Table-Column-Column1" />
                    <thead>
                        <tr class="TableStyle-Default-Table-Head-Header1">
                            <th class="TableStyle-Default-Table-HeadE-Column1-Header1">Parameter</th>
                            <th class="TableStyle-Default-Table-HeadD-Column1-Header1">Description</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr class="TableStyle-Default-Table-Body-Body1" MadCap:conditions="Default.v2021X">
                            <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                <p class="table-text">(,((</p>
                                <div class="info" MadCap:autonum="&lt;b&gt;Info&lt;/b&gt;">
                                    <p class="note">Available from Release v2021.0 onwards</p>
                                </div>
                            </td>
                            <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                <p style="text-align: left;" class="table-text">Select the required open parenthesis.&#160;</p>
                                <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
                                    <p class="note">The open and close parenthesis allow you to create complex queries from the basic query condition option from the user interface.</p>
                                </div>
                            </td>
                        </tr>
                        <tr class="TableStyle-Default-Table-Body-Body1">
                            <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                <p class="table-text">Object</p>
                            </td>
                            <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                <p class="table-text">You can select Object as: user, endpoints, attribute, or entitlement in condition. The Object specified holds the key to trigger condition and evaluate when a request is made from ARS.</p>
                            </td>
                        </tr>
                        <tr class="TableStyle-Default-Table-Body-Body1">
                            <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                <p class="table-text">Attribute</p>
                            </td>
                            <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                <p class="table-text">Based on Object selected the attribute drop-down values are displayed. For example, for users object, you can see username, firstname, lastname. For endpoint object, you can see parentEndpointkey, securitysystemkey, and so on.</p>
                            </td>
                        </tr>
                        <tr class="TableStyle-Default-Table-Body-Body1">
                            <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                <p class="table-text">Condition</p>
                            </td>
                            <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                <p class="table-text">Condition allows you to include conditions such as equals, greater than, less than, contains, starts with, Does not Contain, Not Equals, Not Null, Is Null, and Is Updated.</p>
                            </td>
                        </tr>
                        <tr class="TableStyle-Default-Table-Body-Body1">
                            <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                <p class="table-text">Value</p>
                            </td>
                            <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                <p class="table-text">Enter the value for the specified attribute, which you want to match.</p>
                            </td>
                        </tr>
                        <tr class="TableStyle-Default-Table-Body-Body1" MadCap:conditions="Default.v2021X">
                            <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                <p class="table-text">),))</p>
                                <div class="info" MadCap:autonum="&lt;b&gt;Info&lt;/b&gt;">
                                    <p class="note">Available from Release v2021.0 onwards</p>
                                </div>
                            </td>
                            <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                <p style="text-align: left;" class="table-text">Select the required close parenthesis.&#160;</p>
                                <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
                                    <p class="note">The open and close parenthesis allow you to create complex queries from the basic query condition option from the user interface.</p>
                                </div>
                            </td>
                        </tr>
                        <tr class="TableStyle-Default-Table-Body-Body1">
                            <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                <p class="table-text">Next Condition</p>
                            </td>
                            <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                <p class="table-text">The following options are available when adding multiple conditions.</p>
                                <ul>
                                    <li>
                                        <p class="note">AND&#160;- Select this option if all the conditions must be checked while registering a user.</p>
                                    </li>
                                    <li>
                                        <p class="note">OR - Select this option if either of the condition if true while registering a user.</p>
                                    </li>
                                </ul>
                            </td>
                        </tr>
                        <tr class="TableStyle-Default-Table-Body-Body1">
                            <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                <p class="table-text">Action</p>
                            </td>
                            <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                <p class="table-text">Click the <strong>Actions</strong> drop-down and select what action you want to trigger related to organization, when the condition matches.</p>
                                <ul>
                                    <li>
                                        <p class="table-text">Add entitlements from organization: Selecting this will add the respective entitlements from the organization.</p>
                                    </li>
                                    <li>
                                        <p class="table-text">Add Associated Entitlements:&#160;Selecting this will add the respective associated entitlements from the organization.</p>
                                    </li>
                                    <li>
                                        <p class="table-text">Remove Entitlements from organization:&#160;Selecting this will remove the already assigned entitlements from the organization.</p>
                                    </li>
                                </ul>
                            </td>
                        </tr>
                        <tr class="TableStyle-Default-Table-Body-Body1">
                            <td colspan="1" class="TableStyle-Default-Table-BodyB-Column1-Body1">
                                <p class="table-text">Organization</p>
                            </td>
                            <td colspan="1" class="TableStyle-Default-Table-BodyA-Column1-Body1">
                                <p class="table-text">You can specify the organization dynamic value as a variable, such as&#160;'$Organization'.</p>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </li>
            <li>On submission, you can view the newly created user update rule details in the <strong>Request Rule</strong> list.<br /></li>
            <li>Execute the WSRETRY Job from <strong>Utility &gt; Provisioning Job (WSRETRY)</strong> to create the tasks, complete the tasks and automatically perform provisioning or de-provisioning of specified actions to the third-party application.&#160;</li>
        </ol>
    </body>
</html>